<?php
/*************************

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 3
  as published by the Free Software Foundation.
  
**********************************************/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');
if (!defined('PLUGINMGR_PHP')) {
    define('PLUGINMGR_PHP', true);
}
if (!defined('ADMIN_PHP')) {
    define('ADMIN_PHP', true);
}
if (!defined('CORE_PLUGIN')) {
    define('CORE_PLUGIN', true);
}

$icon_array['ok']  = cpg_fetch_icon('ok', 2);

// Add plugin_install action
$thisplugin->add_action('plugin_install','oauth_install');

// Add plugin_uninstall action
$thisplugin->add_action('plugin_uninstall','oauth_uninstall');

// Add a configure action
$thisplugin->add_action('plugin_configure','oauth_configure');

// Add plugin_cleanup action
$thisplugin->add_action('plugin_cleanup','oauth_cleanup');

function oauth_configure() {
    global $lang_plugin_php, $CONFIG, $lang_common, $lang_pluginmgr_php, $lang_admin_php, $icon_array;
    $superCage = Inspekt::makeSuperCage();
    if (!defined('ADMIN_PHP')) {
        defined('ADMIN_PHP');
    }
    $action = $superCage->server->getEscaped('REQUEST_URI');
    $matches = $superCage->post->getMatched('main_page_layout', '/^[0-9a-z,\/]{1,}$/' );
    $contentOfTheMainpage_array = explode('/',$matches[0]);
    if (in_array('oauth', $contentOfTheMainpage_array) == TRUE) {
        // We have a winner
    }

    $icon_array['ok']  = cpg_fetch_icon('ok', 2);
    list($timestamp, $form_token) = getFormToken();
    echo <<< EOT
    <form action="{$action}" method="post" name="oauth_configure">
        <table border="0" cellspacing="0" cellpadding="0" width="100%">
            <tr>
                <td class="tableb" align="center" width="100%">Enable Oauth Plugin</td>
            </tr>
            <tr>
                <td class="tablef">
                </td>
                <td class="tablef">
                    <button type="submit" class="button" name="submit" value="{$lang_common['go']}">{$icon_array['ok']}{$lang_common['go']}</button>
                    <input type="hidden" name="form_token" value="{$form_token}" />
                    <input type="hidden" name="timestamp" value="{$timestamp}" />
                </td>
            </tr>
        </table>
    </form>
EOT;
}

// Install
function oauth_install() {
    global $CONFIG, $thisplugin;
    $superCage = Inspekt::makeSuperCage();
    require 'include/sql_parse.php';
    $duration = $superCage->post->getInt('duration');

    // create table
    $db_schema = $thisplugin->fullpath . '/schema.sql';
    $sql_query = fread(fopen($db_schema, 'r'), filesize($db_schema));
    $sql_query = preg_replace('/CPG_/', $CONFIG['TABLE_PREFIX'], $sql_query);

    $sql_query = remove_remarks($sql_query);
    $sql_query = split_sql_file($sql_query, ';');

    foreach($sql_query as $q) cpg_db_query($q);
    return true;
}

// Ask if we want to drop the table
function oauth_cleanup($action) {
    global $lang_plugin_php, $CONFIG, $lang_common, $icon_array;
    $superCage = Inspekt::makeSuperCage();
    $cleanup = $superCage->server->getEscaped('REQUEST_URI');
    if ($action===1) {
    print <<< EOT
    <form action="{$cleanup}" method="post">
        <table border="0" cellspacing="0" cellpadding="0">
            <tr>
                <td class="tableb" align="center" width="100%">Disable OAuth Plugin</td>
                <td class="tableb">
                    <input type="radio" name="drop" id="drop_yes" value="1" />
                    <label for="drop_yes" class="clickable_option">{$lang_common['yes']}</label>
                </td>
                <td class="tableb">
                    <input type="radio" name="drop" id="drop_no" checked="checked" value="0" />
                    <label for="drop_no" class="clickable_option">{$lang_common['no']}</label>
                </td>
                <td class="tableb">
                    <button type="submit" class="button" name="submit" value="{$lang_common['go']}">{$icon_array['ok']}{$lang_common['go']}</button>

                </td>
            </tr>
        </table>
    </form>
EOT;
    }
}

// Uninstall (drop?)
function oauth_uninstall() {
    global $CONFIG;
    $superCage = Inspekt::makeSuperCage();

    if (!$superCage->post->keyExists('drop')) {
        return 1;
    }
    
    if ($superCage->post->getInt('drop') != 1) {
        header("Location: pluginmgr.php\n\n");  // go back to plugin manager without installing the plugin
        exit(0);
        return 1;
    }
    
    // Drop the tables
    cpg_db_query("DROP TABLE IF EXISTS {$CONFIG['TABLE_PREFIX']}oauth_token");
    cpg_db_query("DROP TABLE IF EXISTS {$CONFIG['TABLE_PREFIX']}oauth_registry");
    cpg_db_query("DROP TABLE IF EXISTS {$CONFIG['TABLE_PREFIX']}oauth_nonce");

    return true;
}
?>