<?php
/*************************

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 3
  as published by the Free Software Foundation.

**********************************************/

require 'cpg_oauth.php';

define('IN_COPPERMINE', true);
require_once 'include/init.inc.php';
require_once dirname(__FILE__) . '/oauth_request.php';

$superCage = Inspekt::makeSuperCage();

$missingPost = !($superCage->post->keyExists('requester_name') && $superCage->post->keyExists('application_title')  && $superCage->post->keyExists('callback_uri'));
$missingGet = !($superCage->get->keyExists('requester_name') && $superCage->get->keyExists('application_title')  && $superCage->get->keyExists('callback_uri'));
$missingParams =  $missingPost && $missingGet;

if (!USER_ID) {
	if (!$missingParams && CPG_COOKIES_ALLOWED ) {
		if ($superCage->cookie->keyExists($CONFIG['cookie_name'] . "_oauthtmp")) {
			setcookie($CONFIG['cookie_name'].'_oauthtmp', '', time()-3600);
		}
		
		$cookie_arr = Array();
		if ($missingGet){
			$cookie_arr['requester_name'] = $superCage->post->getRaw('requester_name');
			//$cookie_arr['requester_email'] = $superCage->post->getRaw('requester_email');
			$cookie_arr['application_title'] = $superCage->post->getRaw('application_title');
			$cookie_arr['callback_uri'] = $superCage->post->getRaw('callback_uri');
			$cookie_str = serialize($cookie_arr);
		} else {
			$cookie_arr['requester_name'] = $superCage->get->getRaw('requester_name');
			//$cookie_arr['requester_email'] = $superCage->get->getRaw('requester_email');
			$cookie_arr['application_title'] = $superCage->get->getRaw('application_title');
			$cookie_arr['callback_uri'] = $superCage->get->getRaw('callback_uri');
			$cookie_str = serialize($cookie_arr);
		}
		setcookie($CONFIG['cookie_name'].'_oauthtmp', $cookie_str, time() + CPG_DAY, $CONFIG['cookie_path']);
	}

	echo 'Please <a href="../../login.php?referer=plugins/oauth/register.php">login</a> to your user account.';
	exit();
}

if ($missingParams && CPG_COOKIES_ALLOWED && $superCage->cookie->keyExists($CONFIG['cookie_name'] . "_oauthtmp")) {
	$tmpStr = $superCage->cookie->getRaw($CONFIG['cookie_name'] . "_oauthtmp");
	$consumer = unserialize(stripslashes($tmpStr));
	
	setcookie($CONFIG['cookie_name'].'_oauthtmp', '', time()-3600);
} else if ($missingParams){
//    echo <<<EOT
//<form method="POST" action="register.php">
//<label for="requester_name">Requester Name: </label><input type="text" name="requester_name" /><br />
//<label for="requester_email">Requester Email: </label><input type="text" name="requester_email" /><br />
//<label for="application_title">Application Title: </label><input type="text" name="application_title" /><br /><br />
//<label for="callback_uri">Callback Uri: </label><input type="text" name="callback_uri" /><br /><br />
//<button type="submit">Register Consumer</button>
//</form>
//EOT;
	die("Cookies need to be enabled or you need to Login to Coppermine previously");
} else {
	if ($missingGet){
		// Get the consumer's information from POST - is the "/[\w ]+/" regex friendly to non-English languages?
		$name = $superCage->post->getMatched('requester_name', '/[\w ]+/');
		//$email = $superCage->post->getMatched('requester_email', '/\b[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/i'); // regex from install.php
		$application = $superCage->post->getMatched('application_title', '/[\w ]+/');
		$redirect = $superCage->post->getEscaped('callback_uri');
	} else {
		// Get the consumer's information from GET - is the "/[\w ]+/" regex friendly to non-English languages?
		$name = $superCage->get->getMatched('requester_name', '/[\w ]+/');
		//$email = $superCage->get->getMatched('requester_email', '/\b[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/i'); // regex from install.php
		$application = $superCage->get->getMatched('application_title', '/[\w ]+/');
		$redirect = $superCage->get->getEscaped('callback_uri');
	}
	
	$consumer = array(
		'requester_name' => $name[0],
		//'requester_email' => $email[0],
		'application_title' => $application[0],
		'callback_uri' => $redirect
	);
}

foreach ($consumer as $key => $value) {
    if ($value == '') {
        throw new OAuthException($key . ' is undefined in HTTP POST');
    }
}

$store = OAuthStore::instance();
// Register the consumer in the database and print out the resulting consumer key
$consumer_id = $store->updateConsumer($consumer, USER_ID, true);
//$data = array();
//$data['consumer_token'] = $consumer_id;
//$result = array();
//$result['success'] = 'true';
//$result['data'] = $data;
//print_r(json_encode($result));

OAuthRequest::redirect($consumer['callback_uri'], array('consumer_token'=>rawurlencode($consumer_id))); //might end with #cpgMessageBlock
?>